<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Recipe extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		session_start();
	}
	
	function index()
	{
		$this->load->helper('url');
		$this->load->model('recipe_model');
		
		$populars = $this->recipe_model->get_Populars();
		$data = array ('recipes' => $populars);
		
		$this->load->view('recipe_template_top');
		$this->load->view('recipe_main', $data);
		$this->load->view('recipe_template_bot');
	}
	
	function recipe_new()
	{
		$this->load->helper('url');
		$this->load->helper('form');
		$this->load->library('form_validation');
		$this->load->model('recipe_model');
	
		$this->form_validation->set_rules('FoodName', 'nev', 'trim|required|xss_clean');
		$this->form_validation->set_rules('Time', 'ido', 'trim|required|xss_clean');
		$this->form_validation->set_rules('Difficulty', 'nehezseg', 'trim|required|xss_clean');
		$this->form_validation->set_rules('Ingredients', 'hozzavalok', 'trim|required|xss_clean');
		$this->form_validation->set_rules('Instructions', 'elkeszites', 'trim|required|xss_clean');
		
		if($this->form_validation->run() == false)
		{
			$this->load->view('recipe_template_top');
			$this->load->view('recipe_new');
			$this->load->view('recipe_template_bot');
		}
		else
		{		
			$foodName = $this->input->post('FoodName');
			$time = $this->input->post('Time');
			$difficulty = $this->input->post('Difficulty');
			$ingredients = $this->input->post('Ingredients');
			$instructions = $this->input->post('Instructions');
		
			$this->recipe_model->insert($foodName, $time, $difficulty, $ingredients, $instructions);
			$temp = $this->recipe_model->get_RecipeByName($foodName);
			$id = $temp['0']->id;
			redirect("recipe/recipe_details/$id");
		}
	}
	
	function recipe_search()
	{
		$this->load->helper('url');
		$this->load->helper('form');
		
		$this->load->view('recipe_template_top');
		$this->load->view('recipe_search');
		$this->load->view('recipe_template_bot');
	}
	
	function recipe_result()
	{
		$this->load->helper('url');
		$this->load->helper('form');
		$this->load->model('recipe_model');
		
		$keyword = $this->input->post('FoodName');
		$include = split(',', $this->input->post('IngrIncl'));
		$exclude = split(',', $this->input->post('IngrExcl'));
		
		$data = array ('recipes' => $this->recipe_model->search_Recipes($keyword, $include, $exclude));
		$this->load->view('recipe_template_top');
		$this->load->view('recipe_result', $data);
		$this->load->view('recipe_template_bot');
	}
	
	function recipe_cookbook()
	{
		$this->load->helper('url');
		$this->load->model('recipe_model');
		
		if(isset($_SESSION['cookbook']))
		{
			$cookbook = array();
			foreach($_SESSION['cookbook'] as $cb)
			{
				$cookbook[] = $this->recipe_model->get_RecipeById($cb);
			}
			$data = array ('cookbook' => $cookbook);
		}
		else
		{
			$data = array ('cookbook' => array());
		}
		
		$this->load->view('recipe_template_top');
		$this->load->view('recipe_cookbook', $data);
		$this->load->view('recipe_template_bot');
	}
	
	function recipe_details($id)
	{
		$this->load->helper('url');
		$this->load->model('recipe_model');
		
		$data = array('recipe' => $this->recipe_model->get_RecipeById($id), 'id'=>$id);

		$this->load->view('recipe_template_top');
		$this->load->view('recipe_details', $data);
		$this->load->view('recipe_template_bot');
	}
	
	function add($id)
	{
		$this->load->helper('url');
		$this->load->model('recipe_model');
		$this->load->library('request');
		
		$this->recipe_model->incAdded($id);
		
		if(isset($_SESSION['cookbook']))
		{
			if (!in_array($id, $_SESSION['cookbook']))
			{
				$_SESSION['cookbook'][]=$id;
			}
		}
		else
		{
			$_SESSION['cookbook'] = array ($id);
		}
		
		if($this->request->is_ajax())
		{
			$this->load->view('ajax/success');
		}
		else
		{
			redirect("recipe/recipe_details/$id");
		}
	}
	
	function prev_next()
	{
		$this->load->helper('url');
		$this->load->library('request');
		
		if($this->request->is_ajax())
		{
			$this->load->view('ajax/success');
		}
		else
		{
			redirect("recipe/recipe_cookbook");
		}
	}
	
	function del($id)
	{
		$this->load->helper('url');
		$this->load->library('request');
			
		$_SESSION['cookbook'] = array_diff($_SESSION['cookbook'], array($id));
		$_SESSION['cookbook'] = array_values($_SESSION['cookbook']);
		
		if($this->request->is_ajax())
		{
			$this->load->view('ajax/success');
		}
		else
		{
			redirect("recipe/recipe_cookbook");
		}
	}
}